<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta
  http-equiv="Content-Type"
  content="text/html; charset=iso-8859-1">
<title>WTP Source Editing</title>
<link
  rel="stylesheet"
  type="text/css"
  href="../sources/formate.css">
</head>
<body>
<p class="ueberschrift">Structured Source Editor (SSE) Tools</p>
<p>The sse component contains the Structured Source Editor framework.
This framework provides some abstract models and ui infrastructure
slightly above the base text infrastructure but lower than any specific
language which uses it, such as XML, CSS, HTML, and JSP. The component
lead is David Williams.</p>

<div align="center">
<p class="ueberschrift">WTP Source Editing</p>
</div>
<p class="ueberschrift">End Users Features</p>
<ul>
  <li>Well behaved, well integrated Eclipse editors</li>
  <li>Seamless user experience</li>
  <li>Search, refactor, debug</li>
</ul>
<p class="ueberschrift">Add<a name="Add"></a>-on/Extender Features</p>
<ul>
  <li>Light weight Framework for content based editing
  <ul>
    <li>Easily embedded in other (multipage) editors</li>
    <li>Easy to extend outline view, properties view, source validation
    for 'mark up' languages (content assist?)</li>
    <li>Extensible, based on contentType and nested contentType</li>
  </ul>
  </li>
  <li>Model Text and DOM APIs
  <ul>
    <li>Fault tolerant, incremental parsing</li>
    <li>Careful tracking of exact source locations</li>
    <li>Translation from one source representation to another</li>
    <li>Notification to keep models 'in synch'</li>
  </ul>
  </li>
  <li>Possible (post 1.0) Future
  <ul>
    <li>Framework for Language Providers</li>
  </ul>
  </li>
</ul>
<p class="ueberschrift">Related Standards</p>
<ul>
  <li>XML 1.0 (not 1.1, that is, no supplementary characters)</li>
  <li>JSP 1.1, 1.2</li>
  <li>JSP 2.0 (mostly, lacking support for some deployment attributes)</li>
  <li>HTML 4.01 (plus a little)</li>
  <li>DOM Level 2 Core APIs (mostly, some not implemented)</li>
  <li>XHTML 1.0, 1.1</li>
  <li>Note: Our 'DOM Parser' is not a 'standard' (per spec) XML Parser,
  since parses ill-formed input with heuristics
  <ul>
    <li>The implication for clients is that it really is for source
    editing, not parsing in general</li>
  </ul>
  </li>
  <li>Similar for JSPs, we parse them as if DOM, not per spec
  <ul>
    <li>Future: want to support JSP as CSS too</li>
  </ul>
  </li>
</ul>
<p class="ueberschrift">Related Open Source Projects (IP)</p>
<ul>
  <li>Xerces</li>
  <li>w3c DTDs and Schemas</li>
  <li>w3c DOM Interfaces</li>
  <li>J2EE DTDs and Schemas(redistribution/caching being investigated)</li>
</ul>
<p class="ueberschrift">API (Provisional)</p>
<ul>
  <li>All Provisional in 0.7
  <ul>
    <li>Partially Spec'd, some JUnit coverage, some refactoring required
    </li>
  </ul>
  </li>
  <li>API Categories
  <ul>
    <li>IDs (editors IDs, content types, partition types)</li>
    <li>ContentType Properties</li>
    <li>Some extensions to base API</li>
    <li>Extension Points (e.g. source page validation)
    <ul>
      <li>Note: some extension points we currently have will be remove</li>
    </ul>
    </li>
    <li>DOM related Implementation and extended APIs</li>
  </ul>
  </li>
</ul>
<p class="ueberschrift">What's the future<a name="future"></a> hold</p>
<ul>
  <li>Post 0.7 (uncommitted possibilities)
  <ul>
    <li>Provide 'Language Provider' API</li>
    <li>Participatory 'Quick Fix' (see TPTP Validation)</li>
    <li>XML/Schema refactoring</li>
    <li>Full spec support (JSP 2.0, XML 1.1?)</li>
    <li>Validation targeted to browser/server/level of spec</li>
    <li>Integrated with Tag Lib editing</li>
    <li>XML Document Editing</li>
  </ul>
  </li>
</ul>
<br>
<br>
</body>
</html>
